(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@yellicode/elements'), require('@yellicode/core')) :
    typeof define === 'function' && define.amd ? define(['exports', '@yellicode/elements', '@yellicode/core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["yellicode-java-extension"] = {}, global.elements, global.core));
})(this, (function (exports, elements, core) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var elements__namespace = /*#__PURE__*/_interopNamespace(elements);

    /**
     * Enumerates the possible collection types to generated for properties and parameters.
     */
    exports.CollectionType = void 0;
    (function (CollectionType) {
        CollectionType[CollectionType["ICollection"] = 0] = "ICollection";
        CollectionType[CollectionType["IEnumerable"] = 1] = "IEnumerable";
        CollectionType[CollectionType["IList"] = 2] = "IList";
    })(exports.CollectionType || (exports.CollectionType = {}));
    exports.NamespaceFeatures = void 0;
    (function (NamespaceFeatures) {
        NamespaceFeatures[NamespaceFeatures["None"] = 0] = "None";
        NamespaceFeatures[NamespaceFeatures["All"] = 0] = "All";
    })(exports.NamespaceFeatures || (exports.NamespaceFeatures = {}));
    exports.ClassFeatures = void 0;
    (function (ClassFeatures) {
        ClassFeatures[ClassFeatures["None"] = 0] = "None";
        ClassFeatures[ClassFeatures["XmlDocSummary"] = 1] = "XmlDocSummary";
        ClassFeatures[ClassFeatures["Generalizations"] = 2] = "Generalizations";
        ClassFeatures[ClassFeatures["InterfaceRealizations"] = 4] = "InterfaceRealizations";
        ClassFeatures[ClassFeatures["All"] = 7] = "All";
    })(exports.ClassFeatures || (exports.ClassFeatures = {}));
    exports.StructFeatures = void 0;
    (function (StructFeatures) {
        StructFeatures[StructFeatures["None"] = 0] = "None";
        StructFeatures[StructFeatures["XmlDocSummary"] = 1] = "XmlDocSummary";
        StructFeatures[StructFeatures["InterfaceRealizations"] = 2] = "InterfaceRealizations";
        StructFeatures[StructFeatures["All"] = 3] = "All";
    })(exports.StructFeatures || (exports.StructFeatures = {}));
    exports.InterfaceFeatures = void 0;
    (function (InterfaceFeatures) {
        InterfaceFeatures[InterfaceFeatures["None"] = 0] = "None";
        InterfaceFeatures[InterfaceFeatures["XmlDocSummary"] = 1] = "XmlDocSummary";
        InterfaceFeatures[InterfaceFeatures["Generalizations"] = 2] = "Generalizations";
        InterfaceFeatures[InterfaceFeatures["All"] = 3] = "All";
    })(exports.InterfaceFeatures || (exports.InterfaceFeatures = {}));
    exports.EnumFeatures = void 0;
    (function (EnumFeatures) {
        EnumFeatures[EnumFeatures["None"] = 0] = "None";
        EnumFeatures[EnumFeatures["XmlDocSummary"] = 1] = "XmlDocSummary";
        /**
         * Writes enumeration member initializers. This flag only applies when values are provided in the model.
         */
        EnumFeatures[EnumFeatures["Initializers"] = 2] = "Initializers";
        EnumFeatures[EnumFeatures["All"] = 3] = "All";
    })(exports.EnumFeatures || (exports.EnumFeatures = {}));
    exports.EnumMemberFeatures = void 0;
    (function (EnumMemberFeatures) {
        EnumMemberFeatures[EnumMemberFeatures["None"] = 0] = "None";
        EnumMemberFeatures[EnumMemberFeatures["XmlDocSummary"] = 1] = "XmlDocSummary";
        /**
         * Writes enumeration member initializers. This flag only applies when values are provided in the model.
         */
        EnumMemberFeatures[EnumMemberFeatures["Initializers"] = 2] = "Initializers";
        EnumMemberFeatures[EnumMemberFeatures["All"] = 3] = "All";
    })(exports.EnumMemberFeatures || (exports.EnumMemberFeatures = {}));
    exports.PropertyFeatures = void 0;
    (function (PropertyFeatures) {
        PropertyFeatures[PropertyFeatures["None"] = 0] = "None";
        PropertyFeatures[PropertyFeatures["XmlDocSummary"] = 1] = "XmlDocSummary";
        /**
         * The access modifier if the owner is not an Interface.
         */
        PropertyFeatures[PropertyFeatures["AccessModifier"] = 2] = "AccessModifier";
        PropertyFeatures[PropertyFeatures["OptionalModifier"] = 4] = "OptionalModifier";
        PropertyFeatures[PropertyFeatures["All"] = 7] = "All";
    })(exports.PropertyFeatures || (exports.PropertyFeatures = {}));
    exports.MethodFeatures = void 0;
    (function (MethodFeatures) {
        MethodFeatures[MethodFeatures["None"] = 0] = "None";
        MethodFeatures[MethodFeatures["XmlDocSummary"] = 1] = "XmlDocSummary";
        MethodFeatures[MethodFeatures["XmlDocParameters"] = 2] = "XmlDocParameters";
        MethodFeatures[MethodFeatures["XmlDocReturns"] = 4] = "XmlDocReturns";
        /**
         * The access modifier if the owner is not an Interface.
         */
        MethodFeatures[MethodFeatures["AccessModifier"] = 8] = "AccessModifier";
        MethodFeatures[MethodFeatures["All"] = 15] = "All";
    })(exports.MethodFeatures || (exports.MethodFeatures = {}));

    const reservedKeywords = [
        'abstract',
        'as',
        'base',
        'bool',
        'break',
        'byte',
        'case',
        'catch',
        'char',
        'checked',
        'class',
        'const',
        'continue',
        'decimal',
        'default',
        'delegate',
        'do',
        'double',
        'else',
        'enum',
        'event',
        'explicit',
        'extern',
        'false',
        'finally',
        'fixed',
        'float',
        'for',
        'foreach',
        'goto',
        'if',
        'implicit',
        'in',
        'int',
        'interface',
        'internal',
        'is',
        'lock',
        'long',
        'namespace',
        'new',
        'null',
        'object',
        'operator',
        'out',
        'override',
        'params',
        'private',
        'protected',
        'public',
        'readonly',
        'ref',
        'return',
        'sbyte',
        'sealed',
        'short',
        'sizeof',
        'stackalloc',
        'static',
        'string',
        'struct',
        'switch',
        'this',
        'throw',
        'true',
        'try',
        'typeof',
        'uint',
        'ulong',
        'unchecked',
        'unsafe',
        'ushort',
        'using',
        'virtual',
        'void',
        'volatile',
        'while',
    ];
    // https://docs.oracle.com/javase/tutorial/java/nutsandbolts/datatypes.html
    const javaPrimitiveTypes = [
        'byte',
        'short',
        'int',
        'long',
        'float',
        'double',
        'boolean',
        'char',
    ];
    const javaClassTypes = ['String', 'Boolean', 'Integer', 'Long', 'Date'];
    /**
     * Returns true if the input string is a reserved Java keyword.
     * @param input Any input string to check.
     */
    function isReservedKeyword(input) {
        if (!input)
            return false;
        return reservedKeywords.indexOf(input) >= 0;
    }
    function isValidJavaType(input) {
        if (!input)
            return false;
        return (javaPrimitiveTypes.indexOf(input) >= 0 || javaClassTypes.indexOf(input) >= 0);
    }
    function getCapitalezedCamelCase(str) {
        if (!str) {
            return '';
        }
        let out = str
            .replace(/_.{1}/g, (letter) => letter.toUpperCase())
            .replace(/_/g, '')
            .replace(/^.{1}/, (letter) => letter.toUpperCase());
        return out;
    }

    class JavaTypeNameProvider extends elements__namespace.DefaultTypeNameProvider {
        /*override*/
        getTypeNameForType(type, isDataType) {
            if (!type)
                return null;
            if (isDataType) {
                if (elements__namespace.isPrimitiveBoolean(type))
                    return 'boolean';
                if (elements__namespace.isPrimitiveInteger(type))
                    return 'int';
                if (elements__namespace.isPrimitiveReal(type))
                    return 'double'; // By default, a real numeric literal on the right side of the assignment operator is treated as double (https://msdn.microsoft.com/en-us/library/b1e65aza.aspx)
                if (elements__namespace.isPrimitiveString(type))
                    return 'String';
                if (elements__namespace.isPrimitiveObject(type))
                    return 'object';
            }
            return super.getTypeNameForType(type, isDataType);
        }
        static canBeNullable(typedElement, csTypeName) {
            if (!typedElement || !csTypeName)
                return false;
            // A collection cannot be nullable
            if (elements__namespace.isMultiplicityElement(typedElement) &&
                typedElement.isMultivalued()) {
                return false;
            }
            // Check the mapped type name (it could come from a custom TypeNameProvider)
            switch (csTypeName // the following cannot be nullable:
            ) {
                case 'string':
                case 'System.String':
                case 'object':
                case 'System.Object':
                    return false;
            }
            // Check the type itself
            const type = typedElement.type;
            if (!type)
                return false;
            return elements__namespace.isEnumeration(type) || elements__namespace.isDataType(type); // isDataType includes PrimitiveType
        }
    }

    class JavaCommentWriter {
        constructor(writer, maxCommentWidth) {
            this.writer = writer;
            this.maxCommentWidth = maxCommentWidth;
        }
        writeDelimitedCommentParagraph(text) {
            if (text == null)
                return;
            const lines = [text];
            this.writer.writeLine('/*');
            this.writeCommentLines(lines, '* ');
            this.writer.writeLine('*/');
        }
        writeDelimitedCommentLines(lines) {
            if (lines == null)
                return;
            this.writer.writeLine('/*');
            this.writeCommentLines(lines, '* ');
            this.writer.writeLine('*/');
        }
        writeCommentLines(lines, prefix) {
            if (!lines)
                return;
            lines.forEach((line) => {
                if (line == null)
                    return;
                if (this.maxCommentWidth > 0 && line.length > this.maxCommentWidth) {
                    // See if we can split the line
                    const split = core.CodeWriterUtility.wordWrap(line, this.maxCommentWidth);
                    split.forEach((s) => {
                        this.writer.writeLine(`${prefix}${s}`);
                    });
                }
                else
                    this.writer.writeLine(`${prefix}${line}`);
            });
        }
    }

    class XmlDocUtility {
        static getXmlDocLineForParameter(parameter) {
            if (!parameter.docComment)
                return null;
            const commentBodies = XmlDocUtility.joinCommentBodies(parameter.docComment);
            return `<param name=\"${parameter.name}\">${commentBodies}</param>`;
        }
        static getXmlDocLineForReturnParameter(method) {
            if (!method.xmlDocReturns)
                return null;
            const commentBodies = XmlDocUtility.joinCommentBodies(method.xmlDocReturns);
            return `<returns>${commentBodies}</returns>`;
        }
        static getXmlDocLinesForInOutParameters(parameters) {
            if (!parameters)
                return [];
            var lines = [];
            parameters.forEach((p) => {
                const l = XmlDocUtility.getXmlDocLineForParameter(p);
                if (l)
                    lines.push(l);
            });
            return lines;
        }
        static joinCommentBodies(bodies) {
            if (!bodies)
                return '';
            return bodies.join(' ');
        }
    }

    class DefinitionBuilder {
        constructor(typeNameProvider) {
            this.typeNameProvider = typeNameProvider;
        }
        buildPackageDefinition(pack, options) {
            if (!options)
                options = {};
            // We have no namespace features yet, but the NamespaceFeatures type is there for future extension
            options.features === undefined
                ? exports.NamespaceFeatures.All
                : options.features;
            let name;
            if (options.writeFullName) {
                const allPackages = pack.getNestingPackages();
                allPackages.push(pack); // add the package itself
                name = allPackages.map((p) => p.name).join('.');
            }
            else
                name = pack.name;
            return { name: name };
        }
        buildClassDefinition(type, options) {
            // Initialize options and features
            if (!options)
                options = {};
            const features = options.features === undefined
                ? exports.ClassFeatures.All
                : options.features;
            // Build the base definition
            const definition = DefinitionBuilder.buildTypeDefinition(type, !!(features & exports.ClassFeatures.XmlDocSummary), options);
            // Build the class-specific definition
            const addInherist = options.extends ? [options.extends] : undefined;
            const exts = DefinitionBuilder.buildInherits(type, addInherist);
            // When multiple extends only the first is used
            if (exts && (exts === null || exts === void 0 ? void 0 : exts.length) > 1) {
                console.warn(`Java only allows inheritance from  a sigle class, many extends detected: (${exts.join(', ')}) for class: ${type.name}, only ${exts[0]} will be used.`);
            }
            definition.extends = exts ? exts[0] : undefined;
            definition.implements = DefinitionBuilder.buildImplements(type, options.implements);
            if (elements__namespace.isClass(type)) {
                definition.isStatic = options.isStatic;
                definition.isAbstract = type.isAbstract || options.isAbstract;
            }
            return definition;
        }
        buildInterfaceDefinition(type, options) {
            // Initialize options and features
            if (!options)
                options = {};
            const features = options.features === undefined
                ? exports.InterfaceFeatures.All
                : options.features;
            // Build the base definition
            const definition = DefinitionBuilder.buildTypeDefinition(type, !!(features & exports.InterfaceFeatures.XmlDocSummary), options);
            // Build the interface-specific definition
            definition.extends = DefinitionBuilder.buildInherits(type, options.extends);
            return definition;
        }
        buildEnumMemberDefinition(literal, isLast, options) {
            // Initialize options and features
            if (!options)
                options = {};
            const features = options.features === undefined
                ? exports.EnumMemberFeatures.All
                : options.features;
            const buildInitializers = !!(features & exports.EnumFeatures.Initializers);
            // Build the base definition
            const definition = DefinitionBuilder.buildDefinitionBase(literal, !!(features & exports.EnumMemberFeatures.XmlDocSummary));
            // Build the member-specific definition
            definition.isLast = isLast || false;
            if (buildInitializers && literal.specification != null) {
                // using '!=' on purpose
                const specification = literal.specification;
                definition.value = elements__namespace.isLiteralInteger(specification)
                    ? specification.value
                    : undefined;
            }
            return definition;
        }
        buildEnumDefinition(type, options) {
            // Initialize options and features
            if (!options)
                options = {};
            const features = options.features === undefined ? exports.EnumFeatures.All : options.features;
            // Build the base definition
            const definition = DefinitionBuilder.buildDefinitionBase(type, !!(features & exports.EnumFeatures.XmlDocSummary));
            // Build the enum-specific definition
            definition.accessModifier = DefinitionBuilder.getAccessModifierString(type.visibility);
            // Build enum members
            if (elements__namespace.isEnumeration(type) && type.ownedLiterals) {
                const members = [];
                // Pass on enum features to enum member features
                let memberFeatures = exports.EnumMemberFeatures.None;
                if (features & exports.EnumFeatures.XmlDocSummary)
                    memberFeatures |= exports.EnumMemberFeatures.XmlDocSummary;
                if (features & exports.EnumFeatures.Initializers)
                    memberFeatures |= exports.EnumMemberFeatures.Initializers;
                type.ownedLiterals.forEach((literal, index) => {
                    let isLast = index === type.ownedLiterals.length - 1;
                    const member = this.buildEnumMemberDefinition(literal, isLast, {
                        features: memberFeatures,
                    });
                    members.push(member);
                });
                definition.members = members;
            }
            return definition;
        }
        buildPropertyDefinition(property, options) {
            // Initialize options and features
            if (!options)
                options = {};
            const features = options.features === undefined
                ? exports.PropertyFeatures.All
                : options.features;
            const ownerIsInterface = elements__namespace.isInterface(property.owner);
            // Build the base definition
            const definition = DefinitionBuilder.buildDefinitionBase(property, !!(features & exports.PropertyFeatures.XmlDocSummary));
            // Build the property-specific definition
            const typename = this.getFullTypeName(property, options.collectionType || null, 'object');
            definition.isVirtual = options.virtual;
            definition.typeName = typename;
            if (!ownerIsInterface && features & exports.PropertyFeatures.AccessModifier)
                definition.accessModifier = DefinitionBuilder.getAccessModifierString(property.visibility);
            if (features & exports.PropertyFeatures.OptionalModifier &&
                property.lower === 0 &&
                JavaTypeNameProvider.canBeNullable(property, typename)) {
                definition.isNullable = true;
            }
            definition.noSetter = property.isReadOnly || property.isDerived;
            definition.defaultValue = DefinitionBuilder.getDefaultValueString(property.defaultValue);
            return definition;
        }
        buildMethodDefinition(operation, options) {
            if (!options)
                options = {};
            const features = options.features === undefined
                ? exports.MethodFeatures.All
                : options.features;
            const ownerIsInterface = elements__namespace.isInterface(operation.owner);
            // Build the base definition
            const definition = DefinitionBuilder.buildDefinitionBase(operation, !!(features & exports.MethodFeatures.XmlDocSummary));
            definition.isConstructor = operation.isConstructor;
            definition.isStatic = operation.isStatic;
            definition.isPublic = options.isPublic;
            if (!operation.isConstructor) {
                definition.isAbstract = options.isAbstract;
            }
            if (!ownerIsInterface)
                definition.accessModifier = DefinitionBuilder.getAccessModifierString(operation.visibility);
            // Get the return type and documentation
            if (!operation.isConstructor) {
                var returnParameter = operation.getReturnParameter();
                if (returnParameter) {
                    definition.returnTypeName = this.getFullTypeName(returnParameter, options.collectionType || null);
                    if (features & exports.MethodFeatures.XmlDocReturns) {
                        definition.xmlDocReturns =
                            DefinitionBuilder.buildXmlDocSummary(operation);
                    }
                }
            }
            // Build parameter definitions
            definition.parameters = this.buildParameterDefinitions(operation.ownedParameters, options);
            return definition;
        }
        buildParameterDefinitions(params, options) {
            if (!options)
                options = {};
            const features = options.features === undefined
                ? exports.MethodFeatures.All
                : options.features;
            const inOutParameters = [];
            if (!params)
                return inOutParameters;
            params.forEach((p) => {
                if (p.direction === elements.ParameterDirectionKind.return)
                    return;
                const typeName = this.getFullTypeName(p, options.collectionType || null, 'object');
                const paramDefinition = DefinitionBuilder.buildDefinitionBase(p, !!(features & exports.MethodFeatures.XmlDocParameters));
                paramDefinition.isNullable =
                    p.lower === 0 && JavaTypeNameProvider.canBeNullable(p, typeName);
                paramDefinition.typeName = typeName;
                (paramDefinition.defaultValue = DefinitionBuilder.getDefaultValueString(p.defaultValue)),
                    inOutParameters.push(paramDefinition);
            });
            return inOutParameters;
        }
        static buildInherits(type, additional) {
            if (!elements__namespace.isClassifier(type)) {
                return;
            }
            const allNames = [];
            if (type.generalizations) {
                // todo: allow qualifiedName
                allNames.push(...type.generalizations.map((g) => g.general.name));
            }
            if (additional) {
                allNames.push(...additional);
            }
            return allNames.length ? allNames : undefined;
        }
        static buildImplements(type, additional) {
            if (!elements__namespace.isBehavioredClassifier(type)) {
                return;
            }
            const allNames = [];
            if (type.interfaceRealizations) {
                // todo: allow qualifiedName
                allNames.push(...type.interfaceRealizations.map((ir) => ir.contract.name));
            }
            if (additional) {
                allNames.push(...additional);
            }
            return allNames.length ? allNames : undefined;
        }
        static buildXmlDocSummary(element) {
            if (!element.ownedComments || !element.ownedComments.length) {
                return undefined;
            }
            return element.ownedComments.map((c) => c.body);
        }
        static buildTypeDefinition(type, buildXmlDocSummary, options) {
            var definition = DefinitionBuilder.buildDefinitionBase(type, buildXmlDocSummary);
            definition.accessModifier = DefinitionBuilder.getAccessModifierString(type.visibility);
            definition.isPublic = options.isPublic;
            return definition;
        }
        static buildDefinitionBase(element, buildXmlDocSummary) {
            var definition = {
                name: element.name,
                docComment: buildXmlDocSummary
                    ? DefinitionBuilder.buildXmlDocSummary(element)
                    : undefined,
            };
            return definition;
        }
        static getDefaultValueString(defaultValue) {
            if (!defaultValue)
                return undefined;
            return elements__namespace.isLiteralString(defaultValue)
                ? `"${defaultValue.value}"`
                : defaultValue.getStringValue();
        }
        static getAccessModifierString(visibility) {
            switch (visibility) {
                case elements__namespace.VisibilityKind.public:
                    return 'public';
                case elements__namespace.VisibilityKind.private:
                    return 'private';
                case elements__namespace.VisibilityKind.protected:
                    return 'protected';
                default:
                    return undefined;
            }
        }
        getFullTypeName(typedElement, collectionType, fallback) {
            const typeName = this.typeNameProvider.getTypeName(typedElement) || fallback;
            if (!typeName)
                return; // no type name and no fallback
            if (elements__namespace.isMultiplicityElement(typedElement) &&
                typedElement.isMultivalued()) {
                switch (collectionType) {
                    case exports.CollectionType.IList:
                        return `IList<${typeName}>`;
                    case exports.CollectionType.IEnumerable:
                        return `IEnumerable<${typeName}>`;
                    default:
                        return `ICollection<${typeName}>`;
                }
            }
            else
                return typeName;
        }
    }

    /**
     * A CodeWriter for writing Java code from code generation templates. This writer can write classes, interfaces, structs and enumerations and also
     * contains functions for writing namespace blocks and using directives. The JavaWriter is compatible with Yellicode models but can also work
     * independently.
     */
    class JavaWriter extends core.CodeWriter {
        /**
         * Constructor. Creates a new JavaWriter instance using the TextWriter and options provided.
         * @param writer The template's current TextWriter.
         * @param options Optional: the global options for this writer.
         */
        constructor(writer, options) {
            super(writer);
            if (!options)
                options = {};
            this.typeNameProvider =
                options.typeNameProvider || new JavaTypeNameProvider();
            this.definitionBuilder = new DefinitionBuilder(this.typeNameProvider);
            this.indentString = '  ';
            this.maxCommentWidth = options.maxCommentWidth || 100;
            this.commentWriter = new JavaCommentWriter(writer, this.maxCommentWidth);
        }
        writeFileContent(definition, contents) {
            this.writeLine(`package ${definition.package};`);
            contents(this);
            return this;
        }
        writeMainMethod(contents) {
            this.writeLine('public static void main(String[] args) {');
            if (contents) {
                this.increaseIndent();
                contents(this);
                this.decreaseIndent();
            }
            this.writeLine('}');
            return this;
        }
        /**
         * Writes 1 or more using directives, each on a new line.
         * @param values A collection of strings, typically namespace names.
         */
        writeUsingDirectives(...values) {
            values.forEach((v) => {
                this.writeLine(`using ${v};`);
            });
            return this;
        }
        /**
         * Writes an indented block of code, wrapped in opening and closing brackets.
         * @param contents A callback function that writes the contents.
         */
        writeCodeBlock(contents) {
            this.write(' {');
            this.writeEndOfLine();
            this.increaseIndent();
            if (contents)
                contents(this);
            this.decreaseIndent();
            this.writeLine('}');
            return this;
        }
        writeNamespaceBlock(data, contents, options) {
            if (!data)
                return this;
            const definition = elements__namespace.isPackage(data)
                ? this.definitionBuilder.buildPackageDefinition(data, options)
                : data;
            this.writeLine(`namespace ${definition.name}`);
            this.writeCodeBlock(contents);
            return this;
        }
        writeClassBlock(data, contents, options) {
            if (!data)
                return this;
            const definition = elements__namespace.isType(data)
                ? this.definitionBuilder.buildClassDefinition(data, options)
                : data;
            if (definition.docComment) {
                this.writeDocComment(definition.docComment);
            }
            this.writeIndent();
            this.writeAccessModifier(definition);
            if (definition.isStatic) {
                this.write('static ');
            }
            else if (definition.isAbstract) {
                // note that static classes cannot be abstract, hence the else-statement
                this.write('abstract ');
            }
            if (definition.isPublic) {
                this.write('public ');
            }
            this.write(`class ${definition.name}`);
            if (definition.extends) {
                this.writeExtends([definition.extends]);
            }
            this.writeImplements(definition.implements);
            this.writeCodeBlock(contents);
            return this;
        }
        writeInterfaceBlock(data, contents, options) {
            if (!data)
                return this;
            const definition = elements__namespace.isType(data)
                ? this.definitionBuilder.buildInterfaceDefinition(data, options)
                : data;
            if (definition.docComment) {
                this.writeDocComment(definition.docComment);
            }
            this.writeIndent();
            this.writeAccessModifier(definition);
            if (definition.isPublic) {
                this.write('public ');
            }
            this.write(`interface ${definition.name}`);
            this.writeExtends(definition.extends);
            this.writeCodeBlock(contents);
            return this;
        }
        writeEnumerationBlock(data, contents, options) {
            if (!data)
                return this;
            const definition = elements__namespace.isType(data)
                ? this.definitionBuilder.buildEnumDefinition(data, options)
                : data;
            if (definition.docComment) {
                this.writeDocComment(definition.docComment);
            }
            this.writeIndent();
            this.writeAccessModifier(definition);
            this.write(`enum ${definition.name}`);
            this.writeEndOfLine();
            this.writeCodeBlock(contents);
            return this;
        }
        writeEnumeration(data, options) {
            if (!data)
                return this;
            const definition = elements__namespace.isType(data)
                ? this.definitionBuilder.buildEnumDefinition(data, options)
                : data;
            this.writeEnumerationBlock(definition, () => {
                if (definition.members) {
                    definition.members.forEach((memberDefinition) => {
                        this.writeEnumMember(memberDefinition);
                    });
                }
            });
            return this;
        }
        writeEnumMember(data, options, isLast) {
            if (!data)
                return this;
            const definition = elements__namespace.isEnumerationLiteral(data)
                ? this.definitionBuilder.buildEnumMemberDefinition(data, isLast, options)
                : data;
            if (definition.docComment) {
                this.writeDocComment(definition.docComment);
            }
            this.writeIndent();
            this.write(definition.name);
            if (definition.value != null) {
                // using '!=' on purpose
                this.write(` = ${definition.value}`);
            }
            if (!definition.isLast) {
                this.write(',');
            }
            this.writeEndOfLine();
            return this;
        }
        writeMethodDeclaration(data, options) {
            if (!data)
                return this;
            const definition = elements__namespace.isOperation(data)
                ? this.definitionBuilder.buildMethodDefinition(data, options)
                : data;
            if (definition.docComment) {
                this.writeDocComment(definition.docComment);
            }
            if (definition.parameters) {
                this.writeJavaDocParagraph(XmlDocUtility.getXmlDocLinesForInOutParameters(definition.parameters));
            }
            const xmlDocReturns = XmlDocUtility.getXmlDocLineForReturnParameter(definition);
            if (xmlDocReturns) {
                this.writeJavaDocParagraph([xmlDocReturns]);
            }
            this.writeIndent();
            if (!definition.isPublic) {
                this.writeAccessModifier(definition); // Partial methods are implicitly private
            }
            if (definition.isPublic) {
                this.write('public ');
            }
            if (definition.isStatic) {
                this.write('static ');
            }
            else if (definition.isAbstract) {
                this.write('abstract ');
            }
            // partial methods must return void, intentional trailing white space
            else
                this.write(`${definition.returnTypeName || 'void'} `); // intentional trailing white space
            this.write(`${definition.name}(`);
            if (definition.parameters) {
                this.writeParameters(definition.parameters);
            }
            this.write(')');
            if (definition.throws) {
                this.write(' throws ');
                this.write(definition.throws.join(', '));
            }
            this.write(';');
            this.writeEndOfLine();
            return this;
        }
        writeMethodBlock(data, contents, options) {
            if (!data)
                return this;
            const definition = elements__namespace.isOperation(data)
                ? this.definitionBuilder.buildMethodDefinition(data, options)
                : data;
            // Write the documentation
            if (definition.docComment) {
                this.writeDocComment(definition.docComment);
            }
            if (definition.parameters) {
                this.writeJavaDocParagraph(XmlDocUtility.getXmlDocLinesForInOutParameters(definition.parameters));
            }
            const xmlDocReturns = definition.isConstructor
                ? null
                : XmlDocUtility.getXmlDocLineForReturnParameter(definition);
            if (xmlDocReturns) {
                this.writeJavaDocParagraph([xmlDocReturns]);
            }
            // Start of the actual method
            this.writeIndent();
            // Write the access modifier
            if (definition.isPublic) {
                this.write('public ');
            }
            else {
                this.writeAccessModifier(definition);
            }
            // Writes the default keyword if it's required
            if (definition.isDefault) {
                this.write('default ');
            }
            // Write the non-access modifier
            this.writeNonAccessModifier(definition.nonAccessModifier);
            // Write the return type
            this.write(`${definition.returnTypeName || 'void'} `); // intentional trailing white space
            this.write(`${definition.name}(`);
            if (definition.parameters) {
                this.writeParameters(definition.parameters);
            }
            this.write(')');
            if (definition.throws) {
                this.write(' throws ');
                this.write(definition.throws.join(', '));
            }
            if (definition.isAbstract) {
                this.writeEndOfLine(';');
            }
            else {
                this.writeCodeBlock(contents);
            }
            return this;
        }
        /**
         * Writes a setter
         * @param param
         * @param methodName Method name without the set prefix
         */
        writeSetterMethod(param, methodName) {
            if (!methodName) {
                methodName = param.name.replace(/^.{1}/, (letter) => letter.toLocaleUpperCase());
            }
            this.writeLine(`public void set${methodName}(${param.typeName} ${param.name}) {`);
            this.increaseIndent();
            this.writeLine(`this.${param.name} = ${param.name};`);
            this.decreaseIndent();
            this.writeLine(`}`);
        }
        /**
         * Writes a setter
         * @param param
         * @param methodName Method name without the set prefix
         */
        writeGetterMethod(param, methodName) {
            if (!methodName) {
                methodName = param.name.replace(/^.{1}/, (letter) => letter.toLocaleUpperCase());
            }
            this.writeLine(`public ${param.typeName} get${methodName}() {`);
            this.increaseIndent();
            this.writeLine(`return this.${param.name};`);
            this.decreaseIndent();
            this.writeLine(`}`);
        }
        writeParameters(data, options) {
            if (!data || !data.length)
                // without at least 1 element, we cannot determine the type
                return this;
            const definitions = elements__namespace.isParameter(data[0])
                ? this.definitionBuilder.buildParameterDefinitions(data, options)
                : data;
            if (!definitions.length)
                return this;
            let i = 0;
            definitions.forEach((p) => {
                if (i > 0) {
                    this.write(', ');
                }
                this.write(p.typeName);
                if (p.isNullable) {
                    this.write('?');
                }
                this.write(` ${p.name}`);
                if (p.defaultValue) {
                    this.write(` = ${p.defaultValue}`);
                }
                i++;
            });
            return this;
        }
        writeProperty(prop) {
            if (prop.docComment) {
                this.writeDocComment(prop.docComment);
            }
            // Start a new, indented line
            this.writeIndent();
            // Access modifier
            this.writeAccessModifier(prop);
            // Static
            if (prop.isStatic)
                this.write('static ');
            // Type
            this.write(`${prop.typeName} `);
            // Name
            this.write(prop.name);
            // Default value
            this.writePropertyValue(prop);
            // End
            this.write(';');
            this.writeEndOfLine();
            return this;
        }
        writePropertyValue(prop) {
            const value = prop.defaultValue;
            if (value === undefined)
                return this;
            if (prop.typeName == 'String') {
                this.write(` = "${value}"`);
            }
            else {
                this.write(` = ${value}`);
            }
            return this;
        }
        writeAccessModifier(visibilityKind) {
            if (!visibilityKind)
                return this;
            const accessModifier = typeof visibilityKind == 'number'
                ? DefinitionBuilder.getAccessModifierString(visibilityKind) // VisibilityKind
                : visibilityKind.accessModifier; // TypeDefinition
            if (!accessModifier)
                return this;
            this.write(accessModifier);
            this.writeWhiteSpace();
            return this;
        }
        writeNonAccessModifier(nonAccessModifier) {
            if (!nonAccessModifier)
                return this;
            this.write(nonAccessModifier);
            this.writeWhiteSpace();
            return this;
        }
        getTypeName(element) {
            if (!element)
                return null;
            return this.typeNameProvider.getTypeName(element);
        }
        // #region deprecated
        /**
         * Writes a method declaration without a body.
         * @deprecated Use the writeMethodDeclaration() function instead.
         */
        writeInterfaceMethod(operation, options) {
            console.warn('writeInterfaceMethod is deprecated. Use the writeMethodDeclaration() function instead. ');
            this.writeMethodDeclaration(operation, options);
            return this;
        }
        /**
         * Writes an indented block of code, wrapped in a method declaration and opening and closing brackets.
         * @deprecated Use the writeMethodBlock() function instead.
         */
        writeClassMethodBlock(operation, contents, options) {
            console.warn('writeClassMethodBlock is deprecated. Use the writeMethodBlock() function instead. ');
            this.writeMethodBlock(operation, contents, options);
            return this;
        }
        writeDocComment(data) {
            if (elements__namespace.isNamedElement(data)) {
                // we have no isElement check, but this will do
                data = DefinitionBuilder.buildXmlDocSummary(data);
            }
            if (!data)
                return this;
            const array = [];
            if (typeof data == 'string') {
                // string
                array.push(data);
            }
            else {
                // string[]
                array.push(...data);
            }
            if (!array.length)
                return this;
            this.writeLine('/**');
            this.commentWriter.writeCommentLines(array, ' * ');
            this.writeLine(' */');
            return this;
        }
        writeJavaDocParagraph(data) {
            if (data == null)
                return this;
            let lines;
            if (typeof data == 'string') {
                lines = [data];
            }
            else
                lines = data;
            this.writeJsDocLines(lines);
            return this;
        }
        writeJsDocLines(lines) {
            if (lines.length === 0)
                return this;
            this.writeLine('/**');
            // Split here
            lines.forEach((line) => {
                const lineLength = line ? line.length : 0;
                if (this.maxCommentWidth > 0 && lineLength > this.maxCommentWidth) {
                    // See if we can split the line
                    var split = core.CodeWriterUtility.wordWrap(line, this.maxCommentWidth);
                    split.forEach((s) => {
                        this.writeLine(`* ${s}`);
                    });
                }
                else
                    this.writeLine(`* ${line}`);
            });
            this.writeLine('*/');
            return this;
        }
        writeDelimitedCommentParagraph(data) {
            if (typeof data == 'string') {
                this.commentWriter.writeDelimitedCommentParagraph(data);
            }
            else
                this.commentWriter.writeDelimitedCommentLines(data);
            return this;
        }
        writeDelimitedCommentLines(paragraph) {
            console.warn('writeDelimitedCommentLines is deprecated. Use the writeDelimitedCommentParagraph() function instead.');
            this.commentWriter.writeDelimitedCommentLines(paragraph);
            return this;
        }
        //#endregion Xml Docs
        joinWrite(collection, separator, getStringFunc) {
            let isFirst = true;
            collection.forEach((c) => {
                const value = getStringFunc(c);
                if (!value)
                    return;
                if (isFirst) {
                    isFirst = false;
                }
                else
                    this.write(separator);
                this.write(value);
            });
        }
        writeExtends(ext) {
            if (!ext || !ext.length)
                return false;
            this.write(' extends ');
            this.joinWrite(ext, ', ', (name) => name);
            return true;
        }
        writeImplements(impl) {
            if (!impl || !impl.length)
                return false;
            this.write(' implements ');
            this.joinWrite(impl, ', ', (name) => name);
            return true;
        }
        /**
         *
         * @param classList The class list to imported
         */
        writeImports(classList) {
            classList.forEach((cls) => {
                this.writeLine(cls ? `import ${cls};` : '');
            });
        }
    }

    /**
     * Prefixes reserved Java keywords with a "@". This applies to:
     * - Class names
     * - Interface names
     * - Enumeration names
     * - Attribute names
     * - Operation names
     * - Operation parameter names
     */
    class JavaReservedKeywordTransform extends elements.RenamingTransform {
        constructor(targets = elements.RenameTargets.all) {
            super(targets);
        }
        rename(name, target) {
            if (!isReservedKeyword(name))
                return name;
            return `@${name}`;
        }
    }

    exports.JavaReservedKeywordTransform = JavaReservedKeywordTransform;
    exports.JavaTypeNameProvider = JavaTypeNameProvider;
    exports.JavaWriter = JavaWriter;
    exports.getCapitalezedCamelCase = getCapitalezedCamelCase;
    exports.isReservedKeyword = isReservedKeyword;
    exports.isValidJavaType = isValidJavaType;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
